import java.util.Iterator;
import java.util.NoSuchElementException;

public class AnonDiamondDemo
{
   public static void main(String[] args)
   {
      String[] directions = { "North", "South", "East", "West" };
      Iterator<String> iter = new Iterator<>()
                              {
                                 int i = 0;

                                 @Override
                                 public boolean hasNext()
                                 {
                                    return i < directions.length;
                                 }

                                 @Override
                                 public String next()
                                 {
                                    if (!hasNext())
                                       throw new NoSuchElementException();
                                    return directions[i++];
                                 }
                              };
      while (iter.hasNext())
         System.out.println(iter.next());
   }
}